--
--	Mystic Realms Community Editions' OS-Time Events
--	Contributed by Ace Lite, Xian
--

if time_events then
	local funni = false
	
	-- Primordial Abyss, april fools stuff
	-- Map-ID 0 - Global
	time_events.add_event(0, function(cdate)
		if mapheaderinfo[gamemap].lvlttl != "Primordial Abyss" then return end
		if (cdate.day != 1 and cdate.month != 4) and not funni then return end
		
		for s in sectors.iterate do
			for rover in s.ffloors() do
				if (rover.sector.floorpic == "RAINBOWC" 
				or rover.sector.floorpic == "DSBLOCK1" 
				or rover.sector.floorpic == "DSBLOCK3") then
					print("found one")
					if rover.alpha > 5 then
						rover.alpha = 5
						rover.blend = AST_ADD
					end
				end
			end
		end
		time_events.ignore_default = true
	end)
end